-- idle move
local function IdleMove(monster, jval)
    return monster:MoveToRandDestination();
end

-- escaping
local function Escaping(monster, jval)
    sightdistance   = jval["sightdistance"]
    return monster:Escaping(sightdistance)
end

-- observer target
function ObserveTarget(monster, jval)
    return true;
end



-- chasing
local function Chasing(monster, jval)
    target = monster:GetTarget();
    if (target == nil) then
        return false;
    end
if g_AI_DEBUG_LUA_STATE then
    if monster:GetMobType()==mtCreeper then
        print("\n\n\nlua.Creeper.Chasing ","\n\n\n")
    end
end
    monster:MoveToPosition(target:GetPosition());
    return true;
end

-- attack
local function Attack(monster, jval)
    return monster:Attack();
end

-- chasing
local function StopMovingTo(monster, jval)
if g_AI_DEBUG_LUA_STATE then
    if monster:GetMobType()==mtCreeper then
        print("\n\n\nlua.Creeper.StopMovingTo ","\n\n\n")
    end
end
    monster:StopMovingToPosition()
    return true;
end

-- test func
local function SpawnAtPoint(monster, jval)
    world = monster:GetWorld();
    if nil == world then
        return false;
    end

    pickups     = cItems();
    pickups:Add(E_BLOCK_TALL_GRASS, 1, 1);
    target_pos  = monster:GetPosition()

    world:SpawnItemPickups(pickups, target_pos.x, target_pos.y, target_pos.z)
    return true
end

-- set angry state
local function Angry(monster, jval)
    flag = jval["isangry"]
    if (flag == false) then
        if (monster:IsAngrying() == true) then
            monster:SetTarget(nil);
            monster:StopMovingToPosition();
        end
    end
    monster:SetAngryFlag(flag);
    return true;  
end

--[[
Title: CancelHumanBomb
Desc: a period of time after the explosion
Param:  nil
]]
local function CancelHumanBomb( monster, jval)
if g_AI_DEBUG_LUA_STATE then
    if monster:GetMobType()==mtCreeper then
        print("\n\n\nlua.Creeper.CancelHumanBomb. 11111111111111111111111111111111111111111111","\n\n\n")
    end
end
    monster:SetBlowing(false)
    local world = monster:GetWorld();
    if world then
        world:BroadcastEntityMetadata(monster)
    end
    return monster:DelPlannedAction("HumanBomb")
end

--[[
Title:HumanBomb
Desc: a period of time after the explosion
Param: 
javl = {
    "wait_time_ms": 1500,  --millisecond
    "explosion_range":3,
}
]]
local function HumanBomb(monster, jval) 
    -- world:BroadcastEntityMetadata(monster);
-- if g_AI_DEBUG_LUA_STATE then
--     if monster:GetMobType()==mtCreeper then
--         print("\n\n\nlua.Creeper.HumanBomb. 11111111111111111111111111111111111111111111","\n\n\n")
--     end
-- end

    if 1 == jval["call_flag"] then
        return monster:SelfExplosion(jval["explosion_range"])
    end

    monster:SetBlowing(true)
    local world = monster:GetWorld();
    if world then
        world:BroadcastEntityMetadata(monster)
    end

    jval["call_flag"] = 1
    monster:AddPlannedAction("HumanBomb", jval["wait_time_ms"], cJson:Serialize(jval))
    return true
end

--[[
Title:BroadcastSoundEffect
Desc: client play sound
Param:
jval = {
    "sound_id" :"game.tnt.primed" --
}
]]
local function BroadcastSoundEffect(monster, jval)
    monster:BroadcastSoundEffect(jval["sound_id"]);
end

--[[
Title:FireCharge
Desc: fire the a charge
Param: 
javl = {
    ["cooldown"]= 2000 --冷却时间(毫秒)，默认2000,
    ["speed_rate"] = 10 --速度倍率，默认20
}
]]
local function FireCharge(monster, jval) 
    local world = monster:GetWorld();
    if nil == world then
        return false;
    end

    local cooldownFiled = "cooldown_FireCharge"
    if monster:IsExistInPlannedAction(cooldownFiled) then
        return false
    end

    local cooldownInterval = jval["cooldown"] or 2000
    if cooldownInterval<=50 or monster:AddPlannedAction(cooldownFiled, cooldownInterval or 2000) then
        local SpeedBase = monster:GetLookVector()
        local Speed = SpeedBase * (jval["speed_rate"] or 20)
        Speed.y = Speed.y+1;
        return world:MakeProjectileEntityObj( 64, monster, monster:GetPosX()+SpeedBase. x, monster:GetPosY()+SpeedBase.y+1, monster:GetPosZ()+SpeedBase.z, Speed )
    end

    return false
end 


--[[
Title:AddEntityEffect2Target
Desc: add effect to lock target
Param: 
javl = {
    "effect_type"   = 1, //效果类型,0:effNoEffect, 1:effSpeed, 2:effSlowness, 3:effHaste, 4:effMiningFatigue, 5:effStrength, 6:effInstantHealth, 7:effInstantDamage, 8:effJumpBoost, 9:effNausea, 10:effRegeneration, 11:effResistance, 12:effFireResistance, 13:effWaterBreathing, 14:effInvisibility, 15:effBlindness, 16:effNightVision, 17:effHunger, 18:effWeakness, 19:effPoison, 20:effWither, 21:effHealthBoost, 22:effAbsorption, 23:effSaturation, 
    "duration"  = 7*20,   //持续时间,单位:刻(50ms)
    "intensity" = 0,    //强度
    "distance_modifier"  = 1, //距离修饰,The distance modifier for affecting potency,default=1
}
]]
local function AddEntityEffect2Target( monster, jval )
    local effectType = jval["effect_type"]
    local duration = jval["duration"]
    local intensity = jval["intensity"] or 0
    local distance_modifier = jval["distance_modifier"] or 1
    return monster:AddEntityEffect2Target(effectType, duration, intensity, distance_modifier );
end

--[[
Title:SpawnItemPickups
Desc: 产生一个物品
Param: 
javl = {
    "item_type"   = "E_ITEM_EMPTY", //物品类型 
    "item_count"  = 1,   //产生数量，默认为1
    "fly_away_speed" = 0,    //倍率,随机的方向和速度,如果指定了fly_away_speed, 其它指定速度的参数无效,如果没有fly_away_speed,则必须指定speed_x、speed_y和speed_z
    "speed_x" = 1.1, //初始速度
    "speed_y"
    "speed_z"
}
]]
local function SpawnItemPickups( monster, jval  )
    local item_type = _G[jval["item_type"]]
    local item_count = jval["item_count"] or 1
    local speed_x = jval["speed_x"]
    local speed_y = jval["speed_y"]
    local speed_z = jval["speed_z"]
    local fly_away_speed = jval["fly_away_speed"]

    if fly_away_speed then
        return monster:SpawnItemPickups(item_type, item_count, fly_away_speed)
    elseif speed_x and speed_y and speed_z then
        return monster:SpawnItemPickups(item_type, item_count, speed_x, speed_y, speed_z )
    else
        LOGWARN(string.format("AI action:'%s' param error,fly_away_speed=%s,speed_x=%s,speed_y=%s,speed_z=%s,", name, fly_away_speed, speed_x, speed_y, speed_z))
        return false
    end
end

--[[
Title:UnlockPlayer
Desc: 解除对玩家的锁定
Param: 
javl = {}
]]
local function UnlockPlayer( monster, jval  )
    monster:EventLosePlayer()
end

--[[
Title:TakeDamage
Desc: 对自己造成伤害
Param: 
javl = {
    "damage_type" = dtDrowning, //伤害类型
    "raw_damage"   = 1, //基础伤害值
    "knockback_amount"  = 1,   //
    "cooldown" = 50, //伤害冷却时间（毫秒），默认为50
}
]]
local function TakeDamage(monster, jval )
    local cooldownFiled = "cooldown_TakeDamage"
    if monster:IsExistInPlannedAction(cooldownFiled) then
        return false
    end

    local cooldownInterval = jval["cooldown"] or 50
    if cooldownInterval<=50 or monster:AddPlannedAction(cooldownFiled, cooldownInterval) then
        monster:TakeDamage(_G[jval["damage_type"]], nil, jval["raw_damage"], jval["knockback_amount"])
    end
end

--[[
Title:StartBurning
Desc: 开始燃烧自己
Param: 
javl = {
    "ticks_left_burning" = 10  //燃烧时间（刻，50ms）
}
]]
local function StartBurning( monster, jval )
    local TicksLeftBurning = jval["ticks_left_burning"] or 10
    return monster:StartBurning(TicksLeftBurning)
end

--[[
Title:Move2AttacheePlayerFront
Desc: 向骑着自己的玩家前方移动,如果不能被骑、没有或者不是玩家骑着，那么返回失败
Param: none
]]
local function Move2AttacheePlayerFront( monster, jval )
    local attachee = monster.m_Attachee
    if nil==attachee or not attachee:IsPlayer() then
        return false
    end

    return monster:MoveToPosition(attachee:GetPosition() + (attachee:GetLookVector()*10));
end

--[[
Title:SetBodyRotation
Desc: 设置身体趋向，设置后不会自动回位，注意：仅在当前怪没有目标且没有移动时生效
Param: 
{
    "intelvar":本次冷却,在冷却时间内不会被再次设置
    "body_rotation":偏移度[0,360)，默认随机值
}
]]
local function SetBodyRotation( monster, jval )
    local intelvar = jval["intelvar"] 
    local body_rotation = jval["body_rotation"]

    local cooldownFiled = "cooldown_SetRotation"
    if monster:IsExistInPlannedAction(cooldownFiled) then
        return false
    end

    if intelvar<=50 or monster:AddPlannedAction(cooldownFiled, intelvar) then
        if nil==body_rotation then
            local world = monster:GetWorld();
            if nil == world then return false end
            body_rotation = world:GetTickRandomNumber(359)
        end
        monster:SetBodyRotation( body_rotation )
    end

    return true
end

--[[
Title:SetCurBlock
Desc: 设置当前玩家脚下的块为指定块的类型
Param: 
{
    "block_type":,
}
]]
local function SetCurBlock( monster, jval )
    world = monster:GetWorld();
    if nil == world then
        return false;
    end

    local pos_x = math.floor(monster:GetPosX())
    local pos_y = math.floor(monster:GetPosY())
    local pos_z = math.floor(monster:GetPosZ())

    local block_type = _G[jval["block_type"]] --ex:"E_BLOCK_SNOW"
    
    world:SetBlock(pos_x, pos_y, pos_z, block_type, 0)
end


-- PatrolStart 设置巡逻
-- {
--     "enter_type":1,  －－介入方式，1：从起点开始巡逻，2：从最近点开始巡逻
--     "loop_type":1, --循环方式，1：来回巡逻，2：尾头循环
--     "point_idle_tick":0,--到达每个点后的停顿时长
--     "points":{{1,1,1},{2,2,2},{23,97,56}}--循环点列表
-- }
-- 巡逻开始
local function PatrolStart( monster, jval )
    local enter_type        = jval["enter_type"] or 1 --
    local loop_type         = jval["loop_type"] or 1 
    local point_idle_tick   = jval["point_idle_tick"] or 0 
    local points            = jval["points"]

    if monster:IsPatrolling() then return end

    local points_tmp = {}
    for _,v in ipairs(points) do
        monster:PatrolPushPoint(v[1],v[2],v[3])
    end

    monster:PatrolStart(enter_type, loop_type, point_idle_tick)
end

-- 巡逻结束
local function PatrolEnd( monster, jval )
    monster:PatrolEnd()
end

-- 巡逻中断
local function PatrolBreak( monster, jval )
    monster:PatrolBreak()
end

-- 巡逻继续
local function PatrolContinue( monster, jval )
    local interrupt_recover_type = jval["interrupt_recover_type"] --中断恢复方式，1：先回到中断点附近再继续，2：直接前往下一个巡逻目标点
    monster:PatrolContinue(interrupt_recover_type)
end

--仅供函数回调，不开放
local function voidFun( ... )
    
end

-- globle action func list
local action_func_list = {}
action_func_list["Attack"]                  = Attack
action_func_list["Chasing"]                 = Chasing
action_func_list["ObserveTarget"]           = ObserveTarget
action_func_list["Escaping"]                = Escaping
action_func_list["IdleMove"]                = IdleMove
action_func_list["SpawnAtPoint"]            = SpawnAtPoint
action_func_list["Angry"]                   = Angry
action_func_list["HumanBomb"]               = HumanBomb
action_func_list["BroadcastSoundEffect"]    = BroadcastSoundEffect
action_func_list["CancelHumanBomb"]         = CancelHumanBomb
action_func_list["SpawnItemPickups"]        = SpawnItemPickups
action_func_list["FireCharge"]              = FireCharge
action_func_list["cooldown_FireCharge"]     = voidFun
action_func_list["AddEntityEffect2Target"]  = AddEntityEffect2Target
action_func_list["StopMovingTo"]            = StopMovingTo
action_func_list["TakeDamage"]              = TakeDamage
action_func_list["cooldown_TakeDamage"]     = voidFun
action_func_list["UnlockPlayer"]            = UnlockPlayer
action_func_list["StartBurning"]            = StartBurning
action_func_list["Move2AttacheePlayerFront"]= Move2AttacheePlayerFront
action_func_list["SetCurBlock"]             = SetCurBlock
action_func_list["SetBodyRotation"]         = SetBodyRotation
action_func_list["cooldown_SetRotation"]    = voidFun


action_func_list["PatrolStart"]             = PatrolStart
action_func_list["PatrolEnd"]               = PatrolEnd
action_func_list["PatrolBreak"]             = PatrolBreak
action_func_list["PatrolContinue"]          = PatrolContinue






-- action enter
function OnAction(name, param, monster)
    local jval = cJson:Parse(param);
    if jval==nil and ""~=param then
        LOGWARN(string.format("AI action:'%s', parse param error!", name))
        return false;
    end

    func = action_func_list[name];
    if (func == nil) then
        LOGWARN(string.format("AI action:'%s' can't find!", name))
        return false;
    end
    return func(monster, jval)   
end

