g_AI_DEBUG_LUA_STATE = false

-- judge distance
local function JudgeDistance(monster, jval)
if g_AI_DEBUG_LUA_STATE then
    if monster:GetMobType()==mtCreeper then
        print("\n\n\nlua.Creeper.JudgeDistance. 11111111111111111111111111111111111111111111 val[sightdistance]=", jval["sightdistance"], "\n\n\n")
    end
end
    local world = monster:GetWorld();
    if (world == nil) then
        return false;
    end
    sightdistance   = jval["sightdistance"]
    closest         = world:FindClosestPlayer(monster:GetPosition(), math.abs(sightdistance), false, true);

    if (closest ~= nil and sightdistance > 0) then
        monster:SetTarget(closest);
    end

    if (sightdistance <= 0) then
        if closest == nil then
            return true
        else
            return false
        end
    else
        if closest == nil then
            monster:SetTarget(nil)
            return false
        else
            return true
        end
    end
end

local function JedgeTargetIsInDistance( monster, jval)
if g_AI_DEBUG_LUA_STATE then
    if monster:GetMobType()==mtCreeper then
        print("\n\n\nlua.Creeper.monsterJedgeTargetIsInDistance. 22222222222222222222222222222222222222222222,jval[\"sightdistance\"]=",jval["sightdistance"],"\n\n\n")
    end
end
    local world = monster:GetWorld();
    if (world == nil) then
        return false
    end
    local sightdistance   = jval["sightdistance"]
    local target = monster:GetTarget()
    if target == nil then
        return false
    end

    if sightdistance>=0.0 then
        -- print("\nlua.222", (monster:GetPosition() - target:GetPosition()):SqrLength() < sightdistance*sightdistance, "\n")
        return (monster:GetPosition() - target:GetPosition()):SqrLength() < sightdistance*sightdistance 
    else
        -- return false
        -- print("\nlua.333, monster:GetPosition() - target:GetPosition()):SqrLength()=",(monster:GetPosition() - target:GetPosition()):SqrLength(), ", ret=", (monster:GetPosition() - target:GetPosition()):SqrLength() > sightdistance*sightdistance, "\n")
        return (monster:GetPosition() - target:GetPosition()):SqrLength() > sightdistance*sightdistance 
    end
end

-- 
-- monster be attacked
local function Hacked(monster, jval)
    lastdamaged = monster:GetifTicksSinceLastDamaged();
    if (lastdamaged == 0) then
        return true
    end
    return false
end

local function IsAngry(monster, jval)
    return monster:IsAngrying();
end

local function IsNoAngry(monster, jval)
    if monster:IsAngrying() == true then
        return false
    else
        return true
    end
end

local function IsCharged(monster, jval)
    return monster:IsCharged();
end

--[[
Title:IsSwimming
Desc: 是否在水中/游泳
Param: 
javl = {} //
]]
local function IsSwimming( monster, jval  )
    return monster:IsSwimming()
end

local function IsInWater( monster, jval )
    return monster:IsInWater()
end

local function IsOnFire( monster, jval )
    return monster:IsOnFire()
end

--[[是否背负]]
local function IsSaddled( monster, jval )
    return monster:IsSaddled()
end

--[[是否有玩家附加]]
local function IsPlayerAttachee( monster, jval )
    local attacked = monster:GetAttached()
    return attacked ~= nil and attacked:IsPlayer()
end

--[[是否在骑乘状态]]
local function IsAttachTo( monster, jval )
    return monster:IsAttached()
end


--[[是否在被骑乘状态]]
local function IsBeAttach( monster, jval )
    return monster:IsBeAttached()
end

--[[
Title:CheckAttacheeWeaponItemType
Desc: 检查附加的玩家的武器类型是否是指定的类型
Param: 
javl = {
    "item_type":"E_ITEM_EMPTY"
} //
]]
local function CheckAttacheeWeaponItemType( monster, jval )
    local player = monster.m_Attachee
    if nil==player or not player:IsPlayer() then
        return false
    end

    local item_type = jval["item_type"]
    if nil==item_type then 
        return false
    end

    return  player:GetEquippedWeapon().m_ItemType == item_type
end

--[[
Title:IsInBiomeNoDownfall
Desc: 检查所在的生物群落是否是在Downfall中
Param: 
    javl = {} //
]]
local function IsBiomeInDownfall( monster, jval )
    local world = monster:GetWorld();
    if (world == nil) then
        return false
    end

    local biom = world:GetBiomeAt(math.floor(monster:GetPosX()), math.floor(monster:GetPosZ()))
    return (not IsBiomeNoDownfall(biom))
end

--[[是否是站在实地的地表之上]]
local function IsStandInSolidOnAir( monster, jval )
    local world = monster:GetWorld();
    if (world == nil) then
        return false
    end

    local pos_x = math.floor(monster:GetPosX())
    local pos_y = math.floor(monster:GetPosY())
    local pos_z = math.floor(monster:GetPosZ())

    local blockBelow = world:GetBlock(pos_x, pos_y - 1, pos_z)
    local block = world:GetBlock(pos_x, pos_y, pos_z)
    return ((block == E_BLOCK_AIR) and IsSolid(blockBelow))
end


--[[
Title:Probability
Desc: 概率处理器，每次运行按指定概率返回成功与否。例如fraction=20，denominator=100，那么有20/100的机率返回成功；执行时间以刻（50ms）为基准
Param: 
    javl = {
    "fraction":20,  --概率因子
    "denominator":100 --概率基数
    } //
]]
local function Probability( monster, jval )
    local world = monster:GetWorld();
    if (world == nil) then
        return false
    end

    local ai_delay_rate = monster:GetRunAiInterval() / 50

    local fraction = jval["fraction"] * ai_delay_rate
    local denominator = jval["denominator"] - 1

    return world:GetTickRandomNumber(denominator) < fraction
end


-- 巡逻
local function IsPatrolling( monster, jval )
    return monster:IsPatrolling()
end


-- globle action func list
local condition_func_list = {}
condition_func_list["Hacked"]                           = Hacked
condition_func_list["JudgeDistance"]                    = JudgeDistance
condition_func_list["IsAngry"]                          = IsAngry
condition_func_list["IsNoAngry"]                        = IsNoAngry
condition_func_list["IsCharged"]                        = IsCharged
condition_func_list["JedgeTargetIsInDistance"]          = JedgeTargetIsInDistance
condition_func_list["IsSwimming"]                       = IsSwimming
condition_func_list["IsInWater"]                        = IsInWater
condition_func_list["IsOnFire"]                         = IsOnFire
condition_func_list["IsSaddled"]                        = IsSaddled
condition_func_list["CheckAttacheeWeaponItemType"]      = CheckAttacheeWeaponItemType
condition_func_list["IsBiomeInDownfall"]                = IsBiomeInDownfall
condition_func_list["IsStandInSolidOnAir"]              = IsStandInSolidOnAir
condition_func_list["Probability"]                      = Probability
condition_func_list["IsPatrolling"]                      = IsPatrolling



-- condition enter
function OnCondition(name, param, entity)
    local jval = cJson:Parse(param);

    func = condition_func_list[name];
    if (func == nil) then
        LOGWARN(string.format("AI condition:'%s' can't find!", name))
        return false;
    end

    return func(entity, jval)
end

-- print("\r\n\r\n\r\n E_ITEM_EMPTY=", E_ITEM_EMPTY, ",_G[\"E_ITEM_EMPTY\"]=",_G["E_ITEM_EMPTY"],"\r\n\r\n\r\n")


