#include "Uniforms.glsl"
#include "Samplers.glsl"
#include "Transform.glsl"
#include "ScreenPos.glsl"
//#include "MCHeader.glsl"
varying vec2 vScreenPos;

vec4 MCBlendAlpha(vec4 srcColor, vec4 destColor)
{
    float srcOneSubA = 1.0 - srcColor.a;
    return vec4(srcColor.r*srcColor.a + destColor.r*srcOneSubA, srcColor.g*srcColor.a + destColor.g*srcOneSubA, srcColor.b*srcColor.a + destColor.b*srcOneSubA , srcColor.a*srcColor.a + destColor.a*srcOneSubA);
}
void VS()
{
    mat4 modelMatrix = iModelMatrix;
    vec3 worldPos = GetWorldPos(modelMatrix);
    gl_Position = GetClipPos(worldPos);
    vScreenPos = GetScreenPosPreDiv(gl_Position);
}

void PS()
{
    vec4 destMap = vec4(1.0,1.0,1.0,1.0);
    vec4 srcMap = vec4(1.0,1.0,1.0,1.0);
    vec4 finalC = vec4(1.0,1.0,1.0,1.0);
#if defined(DIFFMAP)
    destMap  = texture2D(sDiffMap, vScreenPos);
#endif
#if defined(SPECMAP)
    vec2 srcTextureCoordS = vScreenPos;
#if defined(SPECFLIPX)
    srcTextureCoordS = vec2(1.0 - vScreenPos.x, vScreenPos.y);
#endif
#if defined(SPECFLIPY)
    srcTextureCoordS = vec2(vScreenPos.x, 1.0 - vScreenPos.y);
#endif
    srcMap  = texture2D(sSpecMap , srcTextureCoordS);
#endif
#if defined(EMISSIVEMAP)
    vec2 srcTextureCoordE = vScreenPos;
#if defined(EMISSIVEFLIPX)
    srcTextureCoordE = vec2(1.0 - vScreenPos.x, vScreenPos.y);
#endif
#if defined(EMISSIVEFLIPY)
    srcTextureCoordE = vec2(vScreenPos.x, 1.0 - vScreenPos.y);
#endif
    vec4 emissiveC  = texture2D(sEmissiveMap , srcTextureCoordE);
    float srcOneSubA = 1.0 - srcMap.a;
    srcMap = MCBlendAlpha(emissiveC,srcMap);
#endif
#if defined(ADD)
    finalC = srcMap + destMap;
    finalC = clamp(finalC, vec4(0.0), vec4(1.0));
#elif defined(ALPHA)
    finalC = MCBlendAlpha(srcMap,destMap);
#endif
    gl_FragColor = finalC;
}
