#include "Uniforms.glsl"
#include "Samplers.glsl"
#include "Transform.glsl"
#include "ScreenPos.glsl"
#if defined(DIFFMAP)
    varying vec2 vTexCoord;
#endif
varying vec2 vScreenPos;

void VS()
{
    mat4 modelMatrix = iModelMatrix;
    vec3 worldPos = GetWorldPos(modelMatrix);
    gl_Position = GetClipPos(worldPos);
    vScreenPos = GetScreenPosPreDiv(gl_Position);
    #ifdef DIFFMAP
        vTexCoord = iTexCoord;
    #endif
}

void PS()
{
    #ifdef BOKEH
        vec4 diffInput = texture2D(sDiffMap, vScreenPos);
        gl_FragColor = diffInput;
    #endif
    //本Shader尚未调好
    #ifdef COMBINE
        float depth = texture2D(sNormalMap, vScreenPos).r;
        if(depth>0.5)
        {
            discard;
        }
        vec4 diffInput = texture2D(sDiffMap, vScreenPos);
        gl_FragColor = vec4(diffInput.rgb, depth*depth*depth*depth);
    #endif

}
