#include "Uniforms.glsl"
#include "Samplers.glsl"
#include "Transform.glsl"
#include "ScreenPos.glsl"
#include "PostProcess.glsl"
//#include "MCHeader.glsl"
varying vec2 vScreenPos;

uniform float cGamma;

vec3 ToMCGamma(vec3 color)
{
    return vec3(pow(color.r, cGamma), pow(color.g, cGamma), pow(color.b, cGamma));
}

void VS()
{
    mat4 modelMatrix = iModelMatrix;
    vec3 worldPos = GetWorldPos(modelMatrix);
    gl_Position = GetClipPos(worldPos);
    vScreenPos = GetScreenPosPreDiv(gl_Position);
}

void PS()
{
    vec3 color = texture2D(sDiffMap, vScreenPos).rgb;
    gl_FragColor = vec4(ToMCGamma(color), 1.0);
}
