//SoSo by yuxiaolong define a fog color
//varying vec4 fogColor;
//soso by yuxiaolong
//const Urho3D::String  COLOR= "FogColor";
//const Urho3D::String  Factor = "FogFactor";
//const Urho3D::String  MEASURE = "FogMeasure";
uniform vec3 cMCFogColor;
//x y z factor and fog color alpha factor
uniform vec4 cMCFogFactor;
uniform vec4 cMCFogMeasure;

//input MCSpecColor
uniform vec4 cMCSpecColor;
//influence (x y )   ->  coordinates scale z offset circle
uniform vec3 cMCSpecFactor;

//When get MC fog color call this func
vec4 MCGetFogColor(vec3 worldP ,vec3 CameraP)
{
    vec4 fogColor;
    vec3 deltaPos = worldP.xyz - CameraP.xyz;
    float len = deltaPos.x*deltaPos.x*cMCFogFactor.x+deltaPos.z*deltaPos.z*cMCFogFactor.z;
    float len1 = deltaPos.y*deltaPos.y*cMCFogFactor.y;
    len = (len-cMCFogMeasure.x) / cMCFogMeasure.y;
    len1 = (len1-cMCFogMeasure.z) / cMCFogMeasure.w;
    float fogColorA = max(len,len1);
    fogColor.rgb = cMCFogColor.xyz;
    fogColor.a =clamp(fogColorA, 0.0, 1.0)*cMCFogFactor.a;

    return fogColor;
}

//When get MC fog color call this func
vec4 MCGetFogColorNoFactor(vec3 worldP ,vec3 CameraP)
{
    vec4 fogColor;
    vec3 deltaPos = worldP.xyz - CameraP.xyz;
    float len = deltaPos.x*deltaPos.x*cMCFogFactor.x+deltaPos.z*deltaPos.z*cMCFogFactor.z;
    float len1 = deltaPos.y*deltaPos.y*cMCFogFactor.y;
    len = (len-cMCFogMeasure.x) / cMCFogMeasure.y;
    len1 = (len1-cMCFogMeasure.z) / cMCFogMeasure.w;
    float fogColorA = max(len,len1);
    fogColor.rgb = cMCFogColor.xyz;
    fogColor.a =clamp(fogColorA, 0.0, 1.0);
    return fogColor;
}



//input MCSpecColor
vec4 MCGetSpecColor()
{
#ifdef GL_ES
    mediump vec4 RetSpecColor =  cMCSpecColor; //vec4(cMCSpecColor.x,cMCSpecColor.y,cMCSpecColor.z,cMCSpecColor.w);
    return RetSpecColor;
#else
    return cMCSpecColor;//vec4(cMCSpecColor.x,cMCSpecColor.y,cMCSpecColor.z,cMCSpecColor.w);
#endif
    
}
//influence (x y )   ->  coordinates scale z offset circle
vec3 MCGetSpecFactor()
{
#ifdef GL_ES
    mediump vec3 RetSpecFactor = cMCSpecFactor;//vec3(cMCSpecFactor.x,cMCSpecFactor.y,cMCSpecFactor.z);
    return RetSpecFactor;
#else
    return cMCSpecFactor;//vec3(cMCSpecFactor.x,cMCSpecFactor.y,cMCSpecFactor.z);
#endif
    //return RetSpecFactor;
}


//Guijun

const float fogNear = 0.6;
const float INV_RENDER_DISTANCE=(1.0/(8.0*16.0));
//When get MC fog color call this func
vec4 MCGetFogColorByDepth(vec3 fogColor,vec4 glPosition)
{
    float depth = glPosition.z * INV_RENDER_DISTANCE;
    float fog = max(depth - fogNear, 0.0);
    return vec4(fogColor,fog);
}
