#include "Uniforms.glsl"
#include "Samplers.glsl"
#include "Transform.glsl"
#include "ScreenPos.glsl"
//#include "MCHeader.glsl"
varying vec2 vScreenPos;
void VS()
{
    mat4 modelMatrix = iModelMatrix;
    vec3 worldPos = GetWorldPos(modelMatrix);
    gl_Position = GetClipPos(worldPos);
    vScreenPos = GetScreenPosPreDiv(gl_Position);
}

void PS()
{
    vec4 destMap = vec4(1.0);
    vec2 srcTextureCoord = vScreenPos;
#if defined(FLIPX)
    srcTextureCoord = vec2(1.0 - vScreenPos.x, vScreenPos.y);
#endif
#if defined(FLIPY)
    srcTextureCoord = vec2(vScreenPos.x, 1.0 - vScreenPos.y);
#endif
    
#if defined(DIFFMAP)
    destMap  = texture2D(sDiffMap, srcTextureCoord);
#endif
    
    gl_FragColor = destMap;
}
